program LazStats;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, // this includes the LCL widgetset
  Forms
  { you can add units after this }, MainUnit, Globals, DictionaryUnit,
  OptionsUnit, OutPutUnit, LicenseUnit, DataProcs, TransFrmUnit, FunctionsLib,
  DescriptiveUnit, GraphLib, FreqSpecsUnit, FreqUnit, CrossTabUnit, MatrixLib,
  BreakDownUnit, BoxPlotUnit, BlankFrmUnit, NormalityUnit, Rot3DUnit,
  Printer4Lazarus, PlotXYUnit, BubblePlotUnit, StemLeafUnit, MultXvsYUnit,
  OneSampUnit, TwoCorrsUnit, TwoPropUnit, TtestUnit, BLKANOVAUNIT,
  AnovaTestsUnit, WithinANOVAUnit, AxSAnovaUnit, ABRANOVAUNIT, ANCOVAUNIT,
  LatinSpecsUnit, LatinSqrsUnit, RMatUnit, PartialsUnit, PointsUnit,
  DifferenceUnit, ExpSmoothUnit, FFTUnit, PolynomialUnit, AutoCorUnit,
  MoveAvgUnit, AutoPlotUnit, CanonUnit, GLMUnit, StepFwdMRUnit, BlkMRegUnit,
  BackRegUnit, BestRegUnit, SimultRegUnit, CoxRegUnit, LogRegUnit, LinProUnit,
  DiscrimUnit, RotateUnit, FactorUnit, HierarchUnit, PathUnit, LogLinScreenUnit,
  TwoWayLogLinUnit, ABCLogLinUnit, TestGenUnit, TestScoreUnit, RaschUnit,
  SuccIntUnit, GuttmanUnit, CompRelUnit, KR21Unit, SpBrUnit, RelChangeUnit,
  DIFUnit, PolyDIFUnit, ChiSqrUnit, SpearmanUnit, MannWhitUUnit, ExactUnit,
  ConcordanceUnit, KWANOVAUnit, WilcoxonUnit, CochranQUnit, SignTestUnit,
  FriedmanUnit, BinomialUnit, KendallTauUnit, KaplanMeierUnit, XBarUnit,
  RChartUnit, SigmaChartUnit, CUMSUMUNIT, CCHARTUNIT, PCHARTUnit, UChartUnit,
  CorSimUnit, ERRORCURVESUNIT, PCurvesUnit, DISTRIBUNIT, GenSeqUnit,
  GenRndValsUnit, MultGenUnit, LoanItUnit, SumYrsDepUnit, SLDUnit,
  DblDeclineUnit, RIDITUnit, TwoSLSUnit, WLSUnit, HelpUnit, SortCasesUnit,
  SelectCasesUnit, SelectIfUnit, RandomSampUnit, RangeSelectUnit, GridHelpUnit,
  RecodeUnit, KappaUnit, AvgLinkUnit, kmeansunit, SingleLinkUnit, GenKappaUnit,
  contexthelpunit, CompareDistUnit, matmanunit, scripteditorunit, rowinsertunit,
  rootmethodunit, scriptoptsunit, colinsertunit, gradebookunit, gradingunit,
  ProbzUnit, ProbSmallerzUnit, TwozProbUnit, InversezUnit, ProbChiSqrUnit,
  TprobUnit, FProbUnit, HyperGeoUnit, BNestAUnit, ABCNestedUnit,
  BartlettTestUnit, DataSmoothUnit, GroupFreqUnit, RunsTestUnit, XvsMultYUnit,
  SensUnit, CorrespondenceUnit, EquationUnit, CalculatorUnit, JPEGUnit,
  ResistanceLineUnit, MedianPolishUnit, OneCaseAnovaUnit, SmoothDataUnit,
  SRHTestUnit, AboutUnit, ItemBankingUnit, ItemCodesUnit, TFItemUnit,
  EssayItemUnit, MCItemUnit, MatchItemUnit, TestSpecsUnit, SimpleChiSqrUnit,
  LifeTableUnit, LSMRunit;

//{$IFDEF WINDOWS}{$R LazStats.rc}{$ENDIF}

{$R LazStats.res}

begin
  Application.Initialize;
  Application.CreateForm(TOS3MainFrm, OS3MainFrm);
  Application.CreateForm(TDictionaryFrm, DictionaryFrm);
  Application.CreateForm(TOptionsFrm, OptionsFrm);
  Application.CreateForm(TOutputFrm, OutputFrm);
  Application.CreateForm(TLicenseFrm, LicenseFrm);
  Application.CreateForm(TTransFrm, TransFrm);
  Application.CreateForm(TDescriptiveFrm, DescriptiveFrm);
  Application.CreateForm(TGraphFrm, GraphFrm);
  Application.CreateForm(TFreqSpecsFrm, FreqSpecsFrm);
  Application.CreateForm(TFreqFrm, FreqFrm);
  Application.CreateForm(TCrossTabFrm, CrossTabFrm);
  Application.CreateForm(TBreakDownFrm, BreakDownFrm);
  Application.CreateForm(TBoxPlotFrm, BoxPlotFrm);
  Application.CreateForm(TBlankFrm, BlankFrm);
  Application.CreateForm(TNormalityFrm, NormalityFrm);
  Application.CreateForm(TRot3DFrm, Rot3DFrm);
  Application.CreateForm(TPlotXYFrm, PlotXYFrm);
  Application.CreateForm(TBubbleForm, BubbleForm);
  Application.CreateForm(TStemLeafFrm, StemLeafFrm);
  Application.CreateForm(TMultXvsYFrm, MultXvsYFrm);
  Application.CreateForm(TOneSampFrm, OneSampFrm);
  Application.CreateForm(TTwoCorrsFrm, TwoCorrsFrm);
  Application.CreateForm(TTwoPropFrm, TwoPropFrm);
  Application.CreateForm(TTtestFrm, TtestFrm);
  Application.CreateForm(TBlksAnovaFrm, BlksAnovaFrm);
  Application.CreateForm(TWithinANOVAFrm, WithinANOVAFrm);
  Application.CreateForm(TAxSAnovaFrm, AxSAnovaFrm);
  Application.CreateForm(TABRAnovaFrm, ABRAnovaFrm);
  Application.CreateForm(TANCOVAfrm, ANCOVAfrm);
  Application.CreateForm(TLatinSpecsFrm, LatinSpecsFrm);
  Application.CreateForm(TLatinSqrsFrm, LatinSqrsFrm);
  Application.CreateForm(TRMatFrm, RMatFrm);
  Application.CreateForm(TPartialsFrm, PartialsFrm);
  Application.CreateForm(TPointsFrm, PointsFrm);
  Application.CreateForm(TDifferenceFrm, DifferenceFrm);
  Application.CreateForm(TExpSmoothFrm, ExpSmoothFrm);
  Application.CreateForm(TFFTFrm, FFTFrm);
  Application.CreateForm(TPolynomialFrm, PolynomialFrm);
  Application.CreateForm(TAutocorrFrm, AutocorrFrm);
  Application.CreateForm(TMoveAvgFrm, MoveAvgFrm);
  Application.CreateForm(TAutoPlotFrm, AutoPlotFrm);
  Application.CreateForm(TCannonFrm, CannonFrm);
  Application.CreateForm(TGLMFrm, GLMFrm);
  Application.CreateForm(TStepFwdFrm, StepFwdFrm);
  Application.CreateForm(TBlkMregFrm, BlkMregFrm);
  Application.CreateForm(TBackRegFrm, BackRegFrm);
  Application.CreateForm(TBestRegFrm, BestRegFrm);
  Application.CreateForm(TSimultFrm, SimultFrm);
  Application.CreateForm(TCoxRegFrm, CoxRegFrm);
  Application.CreateForm(TLogRegFrm, LogRegFrm);
  Application.CreateForm(TLinProFrm, LinProFrm);
  Application.CreateForm(TDiscrimFrm, DiscrimFrm);
  Application.CreateForm(TRotateFrm, RotateFrm);
  Application.CreateForm(TFactorFrm, FactorFrm);
  Application.CreateForm(THierarchFrm, HierarchFrm);
  Application.CreateForm(TPathFrm, PathFrm);
  Application.CreateForm(TLogLinScreenFrm, LogLinScreenFrm);
  Application.CreateForm(TTwoWayLogLinFrm, TwoWayLogLinFrm);
  Application.CreateForm(TABCLogLinearFrm, ABCLogLinearFrm);
  Application.CreateForm(TTestGenFrm, TestGenFrm);
  Application.CreateForm(TTestScoreFrm, TestScoreFrm);
  Application.CreateForm(TRaschFrm, RaschFrm);
  Application.CreateForm(TSuccIntFrm, SuccIntFrm);
  Application.CreateForm(TGuttmanFrm, GuttmanFrm);
  Application.CreateForm(TCompRelFrm, CompRelFrm);
  Application.CreateForm(TKR21Frm, KR21Frm);
  Application.CreateForm(TSpBrFrm, SpBrFrm);
  Application.CreateForm(TRelChangeFrm, RelChangeFrm);
  Application.CreateForm(TDIFFrm, DIFFrm);
  Application.CreateForm(TPolyDIFFrm, PolyDIFFrm);
  Application.CreateForm(TChiSqrFrm, ChiSqrFrm);
  Application.CreateForm(TSpearmanFrm, SpearmanFrm);
  Application.CreateForm(TMannWhitUFrm, MannWhitUFrm);
  Application.CreateForm(TFisherFrm, FisherFrm);
  Application.CreateForm(TConcordFrm, ConcordFrm);
  Application.CreateForm(TKWAnovaFrm, KWAnovaFrm);
  Application.CreateForm(TWilcoxonFrm, WilcoxonFrm);
  Application.CreateForm(TCochranQFrm, CochranQFrm);
  Application.CreateForm(TSignTestFrm, SignTestFrm);
  Application.CreateForm(TFriedmanFrm, FriedmanFrm);
  Application.CreateForm(TBinomialFrm, BinomialFrm);
  Application.CreateForm(TKendallTauFrm, KendallTauFrm);
  Application.CreateForm(TKaplanMeierFrm, KaplanMeierFrm);
  Application.CreateForm(TXBarFrm, XBarFrm);
  Application.CreateForm(TRChartFrm, RChartFrm);
  Application.CreateForm(TSigmaChartFrm, SigmaChartFrm);
  Application.CreateForm(TCUMSUMFrm, CUMSUMFrm);
  Application.CreateForm(TcChartFrm, cChartFrm);
  Application.CreateForm(TpChartFrm, pChartFrm);
  Application.CreateForm(TUChartFrm, UChartFrm);
  Application.CreateForm(TCorSimFrm, CorSimFrm);
  Application.CreateForm(TErrorCurvesFrm, ErrorCurvesFrm);
  Application.CreateForm(TPCurvesFrm, PCurvesFrm);
  Application.CreateForm(TDistribFrm, DistribFrm);
  Application.CreateForm(TGenSeqFrm, GenSeqFrm);
  Application.CreateForm(TGenRndValsFrm, GenRndValsFrm);
  Application.CreateForm(TMultGenFrm, MultGenFrm);
  Application.CreateForm(TLoanItFrm, LoanItFrm);
  Application.CreateForm(TSumYrsDepFrm, SumYrsDepFrm);
  Application.CreateForm(TSLDepFrm, SLDepFrm);
  Application.CreateForm(TDblDeclineFrm, DblDeclineFrm);
  Application.CreateForm(TRIDITFrm, RIDITFrm);
  Application.CreateForm(TTwoSLSFrm, TwoSLSFrm);
  Application.CreateForm(TWLSFrm, WLSFrm);
  Application.CreateForm(THelpFrm, HelpFrm);
  Application.CreateForm(TSortCasesFrm, SortCasesFrm);
  Application.CreateForm(TSelectFrm, SelectFrm);
  Application.CreateForm(TSelectIfFrm, SelectIfFrm);
  Application.CreateForm(TRandomSampFrm, RandomSampFrm);
  Application.CreateForm(TRangeSelectFrm, RangeSelectFrm);
  Application.CreateForm(TGridHelpFrm, GridHelpFrm);
  Application.CreateForm(TRecodeFrm, RecodeFrm);
  Application.CreateForm(TWeightedKappaFrm, WeightedKappaFrm);
  Application.CreateForm(TAvgLinkFrm, AvgLinkFrm);
  Application.CreateForm(Tkmeansfrm, kmeansfrm);
  Application.CreateForm(TSingleLinkFrm, SingleLinkFrm);
  Application.CreateForm(TGenKappaFrm, GenKappaFrm);
  Application.CreateForm(TContextHelpForm, ContextHelpForm);
  Application.CreateForm(TCompareDistFrm, CompareDistFrm);
  Application.CreateForm(Tmatmanfrm, matmanfrm);
  Application.CreateForm(Tscripteditorfrm, scripteditorfrm);
  Application.CreateForm(Trowinsertfrm, rowinsertfrm);
  Application.CreateForm(Trootmethodfrm, rootmethodfrm);
  Application.CreateForm(Tscriptoptsfrm, scriptoptsfrm);
  Application.CreateForm(Tcolinsertfrm, colinsertfrm);
  Application.CreateForm(TGradebookFrm, GradebookFrm);
  Application.CreateForm(Tgradingfrm, gradingfrm);
  Application.CreateForm(TProbzForm, ProbzForm);
  Application.CreateForm(TProbSmallerzForm, ProbSmallerzForm);
  Application.CreateForm(TTwozProbForm, TwozProbForm);
  Application.CreateForm(TInversezForm, InversezForm);
  Application.CreateForm(TChiSqrProbForm, ChiSqrProbForm);
  Application.CreateForm(TTprobForm, TprobForm);
  Application.CreateForm(TFForm, FForm);
  Application.CreateForm(THyperGeoForm, HyperGeoForm);
  Application.CreateForm(TBNestedAForm, BNestedAForm);
  Application.CreateForm(TABCNestedForm, ABCNestedForm);
  Application.CreateForm(TBartlettTestForm, BartlettTestForm);
  Application.CreateForm(TSmoothDataForm, SmoothDataForm);
  Application.CreateForm(TGroupFreqForm, GroupFreqForm);
  Application.CreateForm(Trunstestform, runstestform);
  Application.CreateForm(TXvsMultYForm, XvsMultYForm);
  Application.CreateForm(TSensForm, SensForm);
  Application.CreateForm(TCorrespondenceForm, CorrespondenceForm);
  Application.CreateForm(TEquationForm, EquationForm);
  Application.CreateForm(TCalculatorForm, CalculatorForm);
  Application.CreateForm(TJPEGform, JPEGform);
  Application.CreateForm(TResistanceLineForm, ResistanceLineForm);
  Application.CreateForm(TMedianPolishForm, MedianPolishForm);
  Application.CreateForm(TOneCaseAnovaForm, OneCaseAnovaForm);
  Application.CreateForm(TDataSmoothingForm, DataSmoothingForm);
  Application.CreateForm(TSRHTest, SRHTest);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TItemBankFrm, ItemBankFrm);
  Application.CreateForm(TCodesForm, CodesForm);
  Application.CreateForm(TTFItemForm, TFItemForm);
  Application.CreateForm(TEssayItemForm, EssayItemForm);
  Application.CreateForm(TMCItemForm, MCItemForm);
  Application.CreateForm(TMatchItemForm, MatchItemForm);
  Application.CreateForm(TTestSpecsForm, TestSpecsForm);
  Application.CreateForm(TSimpleChiSqrForm, SimpleChiSqrForm);
  Application.CreateForm(TLifeTableForm, LifeTableForm);
  Application.CreateForm(TLSMregForm, LSMregForm);
  Application.Run;
end.

